天天看點

HDU 5305 Friends(簡單DFS) Friends

Friends

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 878    Accepted Submission(s): 422

Problem Description

There are n people

and m pairs

of friends. For every pair of friends, they can choose to become online friends (communicating using online applications) or offline friends (mostly using face-to-face communication). However, everyone in these n people

wants to have the same number of online and offline friends (i.e. If one person has x onine

friends, he or she must have x offline

friends too, but different people can have different number of online or offline friends). Please determine how many ways there are to satisfy their requirements. 

Input

The first line of the input is a single integer T (T=100),

indicating the number of testcases. 

For each testcase, the first line contains two integers n (1≤n≤8) and m (0≤m≤n(n−1)2),

indicating the number of people and the number of pairs of friends, respectively. Each of the next m lines

contains two numbers x and y,

which mean x and y are

friends. It is guaranteed that x≠y and

every friend relationship will appear at most once. 

Output

For each testcase, print one number indicating the answer.

Sample Input

2
3 3
1 2
2 3
3 1
4 4
1 2
2 3
3 4
4 1      

Sample Output

0
2      

Source

2015 Multi-University Training Contest 2

    題意:n個人,分别有各自的朋友,有的關系好,有的關系不好,如今要求

每一個人的朋友中關系好的與關系不好的數量要同樣,問多少種方案?

    思路:由于須要關系好的與關系不好的數量要同樣。是以朋友的數量為奇數

的能夠直接輸出0,(由于奇數沒有辦法讓兩者同樣),推斷完奇數後進行搜尋,先找出朋友中關系好的,剩下的自己主動歸為關系不好的之中,假設出現兩個人之間有一個人好朋友與壞朋友已經滿了的,直接return。一個省時間的地方。

比賽的時候讓隊友做的,當時沒有看出來是搜尋。啊啊啊啊啊

#include<iostream>
#include<algorithm>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>

using namespace std;

int n,m;
int num[10];
int pa[10],pb[10];
int sum;

struct node
{
    int x;
    int y;
}q[100100];

void DFS(int p)
{
    //printf("p = %d
",p);
   if(p == m)
   {
       sum++;
       return ;
   }
   int x = q[p].x;
   int y = q[p].y;
   if(pa[x] && pa[y])
   {
       pa[x]--;
       pa[y]--;
       DFS(p+1);
       pa[x]++;
       pa[y]++;
   }
   if(pb[x] && pb[y])
   {
       pb[x]--;
       pb[y]--;
       DFS(p+1);
       pb[x]++;
       pb[y]++;
   }
}

int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        sum = 0;
        memset(num,0,sizeof(num));
        scanf("%d%d",&n,&m);
        int x,y;
        for(int i=0;i<m;i++)
        {
            scanf("%d%d",&x,&y);
            q[i].x = x;
            q[i].y = y;
            num[x]++;
            num[y]++;
        }
        int flag = 0;
        for(int i=1;i<=n;i++)
        {
            pa[i] = num[i]/2;
            pb[i] = num[i]/2;
            if(num[i]%2 == 1)
            {
                flag = 1;
                break;
            }
        }
        if(flag)
        {
            printf("0
");
            continue;
        }
        DFS(0);
        printf("%d
",sum);
    }
    return 0;
}